Imports System.Net.Mail

'
' Class to send emails, send "net send" messages and write to the eventlog
'
Class Alerts

#Region "API Region"
    'NET_API_STATUS NetMessageBufferSend(
    '  LPCWSTR servername,
    '  LPCWSTR msgname,
    '  LPCWSTR fromname,
    '  LPBYTE buf,
    '  DWORD buflen
    ');
    Private Declare Unicode Function NetMessageBufferSend Lib "NETAPI32.DLL" ( _
        ByVal Server As String, _
        ByVal ToPCName As String, _
        ByVal FromName As String, _
        ByVal Msg As String, _
        ByVal lSize As Integer _
    ) As Integer
#End Region

    '
    ' Send an email to a list of users
    '
    Sub SendEmail(ByVal buf As String)
        Dim mailClient As SmtpClient
        Dim Email As String

        mailClient = New SmtpClient(My.Settings.SMTP_Server)

        For Each Email In My.Settings.Email_List
            ' must have a valid From address to get past our spam filters
            Dim Message As New MailMessage(My.Settings.Sender, Email)

            Message.Subject = "Scheduled Task Alert"
            Message.Body = buf

            mailClient.Send(Message)
        Next

    End Sub

    '
    ' Send a popup message to a list of PCs
    '
    Sub SendMessage(ByVal buf As String)
        Dim PCName As String

        For Each PCName In My.Settings.PC_List
            ' must have a valid "from" Name to work
            NetMessageBufferSend("", PCName, Environment.MachineName, buf, Len(buf) * 2)
        Next
    End Sub

    '
    ' Write to the eventlog
    '
    Sub SendEventLog(ByVal buf As String)
        Dim el As New EventLog
        el.Source = "TaskAlert"
        el.WriteEntry(buf, EventLogEntryType.Warning)
    End Sub
End Class
