Imports System.Data.SqlClient

Public Class SQLTasks
    Public Function CheckTasks(ByVal Server As String) As String
        Dim ConnectString, SQL, buf_day, buf_time, ans As String
        Dim con As New SqlConnection
        Dim cmd As New SqlCommand
        Dim da As New SqlDataAdapter
        Dim dt As New DataTable
        Dim dr As DataRow
        Dim last_run, next_run As Date

        ' build a connection string to one of the system tables
        ConnectString = "Server=" & Server & ";Database=msdb;Trusted_Connection=yes"

        ' the SQL query to get the latest job history
        SQL = "select instance_id, sysjobs.name, sysjobs.enabled, message, sql_message_id, sql_severity, run_date, run_time, next_run_date, next_run_time, run_status"
        SQL &= " from sysjobhistory inner join sysjobs on sysjobhistory.job_id=sysjobs.job_id"
        SQL &= " inner join sysjobschedules on sysjobs.job_id=sysjobschedules.job_id"
        SQL &= " where instance_id in (Select max(instance_id) from sysjobs inner join sysjobhistory on sysjobs.job_id=sysjobhistory.job_id group by name)"

        ' we don't actually attempt to see if SQL Server is installed or running,
        ' instead we just "blast away" at trying to connecting to the datbase and
        ' wait and see if it succeeds or fails (oh, well...)
        Try
            con.ConnectionString = ConnectString
            cmd.Connection = con
            cmd.CommandText = SQL
            da.SelectCommand = cmd
            da.Fill(dt)
        Catch ex As Exception
            Return ""
        End Try

        ans = ""
        For Each dr In dt.Rows
            ' decypher the run dates
            last_run = Date.MinValue
            If Not IsNothing(dr("run_date")) AndAlso CInt(dr("run_date")) > 0 Then
                buf_day = dr("run_date").ToString
                buf_time = dr("run_time").ToString.PadLeft(6, "0"c)
                last_run = CDate(buf_day.Substring(4, 2) & "/" & buf_day.Substring(6, 2) & "/" & buf_day.Substring(0, 4) & " " & buf_time.Substring(0, 2) & ":" & buf_time.Substring(2, 2))
            End If

            next_run = Date.MinValue
            If Not IsNothing(dr("next_run_date")) AndAlso CInt(dr("next_run_date")) > 0 Then
                buf_day = dr("next_run_date").ToString
                buf_time = dr("next_run_time").ToString.PadLeft(6, "0"c)
                next_run = CDate(buf_day.Substring(4, 2) & "/" & buf_day.Substring(6, 2) & "/" & buf_day.Substring(0, 4) & " " & buf_time.Substring(0, 2) & ":" & buf_time.Substring(2, 2))
            End If

            ' did it fail?
            If CInt(dr("enabled")) = 1 And CInt(dr("run_status")) = 0 Then
                ans &= "SQLAgent job '" & dr("name").ToString & "' on server " & Server & " failed with error: " & dr("message").ToString & vbCr
            End If

            ' did it miss a schedule?
            If next_run > Date.MinValue And DateDiff("h", next_run, Now) > 2 And CInt(dr("enabled")) = 1 Then
                ' one-time schedules have the next run date the same as the run date
                If last_run <> next_run Then
                    ans &= "SQLAgent job '" & dr("name").ToString & "' on server " & Server & " missed a schedule" & vbCr
                End If
            End If
        Next

        Return ans
    End Function
End Class
