Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices

Public Class ScheduledTaskByFile
    Private Const BUFSIZE As Integer = 4096
    Private Const SCHED_S_TASK_HAS_NOT_RUN As Integer = &H41303

    Public Function GetTaskInfo(ByVal jobFile As String) As String
        Dim buf(BUFSIZE) As Byte
        Dim fs As FileStream
        Dim buf_size, block_num, block_start, block_size As Integer
        Dim lastResult, StatusCode As Integer

        ' read the file into a buffer
        fs = File.OpenRead(jobFile)
        buf_size = fs.Read(buf, 0, BUFSIZE)
        fs.Close()

        ' First byte of the status code
        If CInt(buf(&H2C)) = 2 Then
            ' disabled
            Return ""
        End If

        ' Last Result
        lastResult = BitConverter.ToInt32(buf, &H28)
        If lastResult <> 0 Then
            Return "Exited with result code of 0x" & Hex(lastResult)
        End If

        ' read the 4 blocks
        block_num = 0
        block_start = &H46
        Do While block_start < buf_size
            block_size = BitConverter.ToInt16(buf, block_start)
            block_start = block_start + (block_size * 2) + 2
            block_num += 1
            If block_num > 4 Then
                Exit Do
            End If
        Loop

        ' the Detailed Status code (block5)
        StatusCode = BitConverter.ToInt32(buf, block_start + 4)
        If StatusCode <> 0 And StatusCode <> SCHED_S_TASK_HAS_NOT_RUN Then
            Dim ex As New System.ComponentModel.Win32Exception(StatusCode)
            Return "Failed with the following error: " & ex.Message
        End If

        Return ""
    End Function
End Class
